// Generated by CoffeeScript 1.6.3
(function() {
  var createRepo, mapValues, optimist, paramDescriptions, prompt, promptOptions;

  createRepo = require('./create-bitbucket-repo');

  prompt = require('prompt');

  optimist = require('optimist');

  mapValues = require('lodash').mapValues;

  paramDescriptions = {
    user: 'Bitbucket username',
    pass: 'Bitbucket password',
    repo: 'Repository name',
    owner: 'Repository owner (defaults to username)'
  };

  optimist.usage('Create a private bitbucket repository.\nUsage: $0').describe('user', paramDescriptions.user).describe('pass', paramDescriptions.pass).describe('repo', paramDescriptions.repo).describe('owner', paramDescriptions.owner);

  if (optimist.argv.h || optimist.argv.help) {
    optimist.showHelp();
    return;
  }

  prompt.override = optimist.argv;

  prompt.start();

  promptOptions = {
    properties: {
      user: {
        message: paramDescriptions.user,
        required: true
      },
      pass: {
        message: paramDescriptions.pass,
        required: true,
        hidden: true
      },
      repo: {
        message: paramDescriptions.repo,
        required: true
      },
      owner: {
        message: paramDescriptions.owner,
        required: false
      }
    }
  };

  prompt.get(promptOptions, function(err, resultWithEmptyStrings) {
    var result;
    result = mapValues(resultWithEmptyStrings, function(val) {
      if ((val != null ? val.length : void 0) <= 0) {
        return null;
      } else {
        return val;
      }
    });
    return createRepo(result.repo, result.user, result.pass, {
      owner: result.owner
    }, function(err, result) {
      if (err) {
        return console.error(err);
      }
      console.log("Great! Now do:");
      console.log("git remote add origin " + result);
      return console.log("git push -u origin --all");
    });
  });

}).call(this);
